---
title: ReadableStreamDefaultReader
slug: Web/API/ReadableStreamDefaultReader
tags:
  - API
  - Fetch
  - Interface
  - ReadableStreamDefaultReader
  - Reference
  - Streams
---
<p>{{APIRef("Streams")}}</p>

<p><span class="seoSummary">The <strong><code>ReadableStreamDefaultReader</code></strong> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> represents a default reader that can be used to read stream data supplied from a network (e.g. a fetch request). </span></p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("ReadableStreamDefaultReader.ReadableStreamDefaultReader", "ReadableStreamDefaultReader()")}}</dt>
 <dd>Creates and returns a <code>ReadableStreamDefaultReader</code> object instance.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("ReadableStreamDefaultReader.closed")}} {{readonlyInline}}</dt>
 <dd>Allows you to write code that responds to an end to the streaming process. Returns a promise that fulfills if the stream becomes closed or the reader's lock is released, or rejects if the stream errors.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("ReadableStreamDefaultReader.cancel()")}}</dt>
 <dd>Cancels the stream, signaling a loss of interest in the stream by a consumer. The supplied reason argument will be given to the underlying source, which may or may not use it.</dd>
 <dt>{{domxref("ReadableStreamDefaultReader.read()")}}</dt>
 <dd>Returns a promise providing access to the next chunk in the stream's internal queue.</dd>
 <dt>{{domxref("ReadableStreamDefaultReader.releaseLock()")}}</dt>
 <dd>Releases the reader's lock on the stream.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following example, an artifical {{domxref("Response")}} is created to stream HTML fragments fetched from another resource to the browser.</p>

<p>It demonstrates the usage of a {{domxref("ReadableStream")}} in combination with a {{jsxref("Uint8Array")}}.</p>

<pre class="brush: js">fetch("https://www.example.org/").then((response) =&gt; {
  const reader = response.body.getReader();
  const stream = new ReadableStream({
    start(controller) {
      // The following function handles each data chunk
      function push() {
        // "done" is a Boolean and value a "Uint8Array"
        return reader.read().then(({ done, value }) =&gt; {
          // Is there no more data to read?
          if (done) {
            // Tell the browser that we have finished sending data
            controller.close();
            return;
          }

          // Get the data and send it to the browser via the controller
          controller.enqueue(value);
          push();
        });
      };

      push();
    }
  });

  return new Response(stream, { headers: { "Content-Type": "text/html" } });
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Streams','#default-reader-class','ReadableStreamDefaultReader')}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ReadableStreamDefaultReader")}}</p>
</div>
